#define _CRT_SECURE_NO_WARNINGS
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef _WIN32
#define MAKE_MAKE_WINDOWS_PATH_LENGHT_MAX (256 * 128 - 1)
#include <string.h> 
#include <windows.h>
#include <stdlib.h>
#include <tchar.h>
#include <wchar.h>
#define DIR_ROOT_PATH "/"
#define DIR_HOME_PATH "."
#define DIR_SLASH '\\'
#else
#include <sys/types.h>
#include <sys/dir.h>
#include <dirent.h>
#include <sys/statvfs.h>
#define DIR_ROOT_PATH "/"
#define DIR_HOME_PATH "."
#define DIR_SLASH "/"
#define idirent struct dirent
#endif
//#include "forge.h"
//#include "imagine.h"

#define MAKE_MAKE_TEXT_ALLOCATION_SIZE 1024
#define MAKE_MAKE_TOKEN_LENGTH_MAX 256

typedef struct{
	char *array;
	unsigned int array_length;
}MakeMakeList;

typedef enum{
	MM_LT_INCLUDES,
	MM_LT_DECLARATIONS,
	MM_LT_DEFINITIONS,
	MM_LT_DEPENDENCY,
	MM_LT_PRAGMA,
	MM_LT_COUNT
}MakeMakeListType;

typedef struct{
	MakeMakeList lists[MM_LT_COUNT];
	char file_name[MAKE_MAKE_TOKEN_LENGTH_MAX];
	int added;
	int header;
}MakeMakeFile;

typedef struct{
	MakeMakeFile *files;
	unsigned int file_count;
	char program_name[MAKE_MAKE_TOKEN_LENGTH_MAX];
	char path[MAKE_MAKE_TOKEN_LENGTH_MAX];
	MakeMakeList options;
}MakeMakeProject;

#ifdef _WIN32 /* Windows implementation of UNIX directory functionality. Copied form Imagine library. */

typedef struct{
	char			d_name[MAKE_MAKE_WINDOWS_PATH_LENGHT_MAX];
}idirent;
 
typedef struct{
	WIN32_FIND_DATAW data; 
	HANDLE			handle;
	idirent			ent;
	unsigned int	drive_letter;
}DIR;

#define MAKE_MAKE_NXT	0x80
#define MAKE_MAKE_SEQ2	0xc0
#define MAKE_MAKE_SEQ3	0xe0
#define MAKE_MAKE_SEQ4	0xf0
#define MAKE_MAKE_SEQ5	0xf8
#define MAKE_MAKE_SEQ6	0xfc
#define MAKE_MAKE_BOM	0xfeff


unsigned int make_make_utf8_to_uint32(char *c, unsigned int *pos)
{
	unsigned int i, bits, character_count = 1, high;
	unsigned int out;

	if((c[*pos] & 0x80) == 0)
		high = (wchar_t)c[*pos];
	else if((c[*pos] & 0xe0) == MAKE_MAKE_SEQ2)
	{
		character_count = 2;
		high = (wchar_t)(c[*pos] & 0x1f);
	}else if((c[*pos] & 0xf0) == MAKE_MAKE_SEQ3)
	{
		character_count = 3;
		high = (wchar_t)(c[*pos] & 0x0f);
	}else if((c[*pos] & 0xf8) == MAKE_MAKE_SEQ4)
	{
		character_count = 4;
		high = (wchar_t)(c[*pos] & 0x07);
	}else if((c[*pos] & 0xfc) == MAKE_MAKE_SEQ5)
	{
		character_count = 5;
		high = (wchar_t)(c[*pos] & 0x03);
	}else if((c[*pos] & 0xfe) == MAKE_MAKE_SEQ6)
	{
		character_count = 6;
		high = (wchar_t)(c[*pos] & 0x01);
	}else
	{
		(*pos)++;
		return 0;
	}
	out = 0;
	bits = 0;
	for(i = 1; i < character_count; i++)
	{
		out |= (wchar_t)(c[character_count - i] & 0x3f) << bits;
		bits += 6;		/* 6 low bits in every byte */
	}
	out |= high << bits;
	(*pos) += character_count;
	return out;
}

unsigned int make_make_uint32_to_utf8(unsigned int character, char *out) /* Copied form Forge library. */
{
	unsigned char bytes[4];
	bytes[0] = (character >> 24) & 0xFF;
	bytes[1] = (character >> 16) & 0xFF;
	bytes[2] = (character >> 8) & 0xFF;
	bytes[3] = character & 0xFF;
	if(character <= 0x0000007f)
	{
		out[0] = bytes[3];
		return 1;
	}else if(character <= 0x000007ff)
	{
		out[1] = MAKE_MAKE_NXT | bytes[3] & 0x3f;
		out[0] = MAKE_MAKE_SEQ2 | (bytes[3] >> 6) | ((bytes[2] & 0x07) << 2);
		return 2;
	}else if(character <= 0x0000ffff)
	{
		out[2] = MAKE_MAKE_NXT | bytes[3] & 0x3f;
		out[1] = MAKE_MAKE_NXT | (bytes[3] >> 6) | ((bytes[2] & 0x0f) << 2);
		out[0] = MAKE_MAKE_SEQ3 | ((bytes[2] & 0xf0) >> 4);
		return 3;
	}else if(character <= 0x001fffff)
	{
		out[3] = MAKE_MAKE_NXT | bytes[3] & 0x3f;
		out[2] = MAKE_MAKE_NXT | (bytes[3] >> 6) | ((bytes[2] & 0x0f) << 2);
		out[1] = MAKE_MAKE_NXT | ((bytes[2] & 0xf0) >> 4) | ((bytes[1] & 0x03) << 4);
		out[0] = MAKE_MAKE_SEQ4 | ((bytes[1] & 0x1f) >> 2);
		return 4;
	}else if(character <= 0x03ffffff)
	{
		out[4] = MAKE_MAKE_NXT | bytes[3] & 0x3f;
		out[3] = MAKE_MAKE_NXT | (bytes[3] >> 6) | ((bytes[2] & 0x0f) << 2);
		out[2] = MAKE_MAKE_NXT | ((bytes[2] & 0xf0) >> 4) | ((bytes[1] & 0x03) << 4);
		out[1] = MAKE_MAKE_NXT | (bytes[1] >> 2);
		out[0] = MAKE_MAKE_SEQ5 | bytes[0] & 0x03;
		return 5;
	}else /* if (*w <= 0x7fffffff) */
	{
		out[5] = MAKE_MAKE_NXT | bytes[3] & 0x3f;
		out[4] = MAKE_MAKE_NXT | (bytes[3] >> 6) | ((bytes[2] & 0x0f) << 2);
		out[3] = MAKE_MAKE_NXT | (bytes[2] >> 4) | ((bytes[1] & 0x03) << 4);
		out[2] = MAKE_MAKE_NXT | (bytes[1] >> 2);
		out[1] = MAKE_MAKE_NXT | bytes[0] & 0x3f;
		out[0] = MAKE_MAKE_SEQ6 | ((bytes[0] & 0x40) >> 6);
		return 6;
	}
}


DIR *opendir(char *path) 
{ 
	DIR *dir;
	if(path != NULL && path[0] != 0)
	{
		unsigned int pos, i;
		WIN32_FIND_DATAW data; 
		HANDLE handle; 
		wchar_t unicode_path[MAKE_MAKE_WINDOWS_PATH_LENGHT_MAX];
		char *post_fix = "*.*";
		for(i = pos = 0; i < MAKE_MAKE_WINDOWS_PATH_LENGHT_MAX - 5 && path[pos] != 0; i++)
			unicode_path[i] = make_make_utf8_to_uint32(path, &pos);
		for(pos = 0; post_fix[pos] != 0; i++)
			unicode_path[i] = (wchar_t)post_fix[pos++];
		unicode_path[i] = 0;
		if((handle = FindFirstFileW(unicode_path, &data)) != INVALID_HANDLE_VALUE)
		{ 
			dir = malloc(sizeof *dir);
			dir->handle = handle;
			dir->data = data;
			dir->ent.d_name[0] = 0;
			dir->drive_letter = -1;
			return dir;
		}
		return NULL;
	}else
	{
		dir = malloc(sizeof *dir);
		dir->handle = NULL;
		dir->ent.d_name[0] = 64;
		dir->ent.d_name[1] = ':';
		dir->ent.d_name[2] = '/';
		dir->ent.d_name[3] = 0;
		dir->drive_letter = GetLogicalDrives() * 2;
		return dir;
	}
}

void closedir(DIR *dir) 
{
	if(dir->drive_letter == -1)
		FindClose(dir->handle);
	free(dir);
}

idirent *readdir(DIR *dir) 
{
	if(dir->drive_letter == -1)
	{
		unsigned int i, pos;
		if(FindNextFileW(dir->handle, &dir->data) != TRUE)
			return NULL;
		for(i = pos = 0; dir->data.cFileName[i] != 0 && pos < MAKE_MAKE_WINDOWS_PATH_LENGHT_MAX - 6; i++)
			pos += make_make_uint32_to_utf8(dir->data.cFileName[i], &dir->ent.d_name[pos]);
		dir->ent.d_name[pos] = 0;
		return &dir->ent;
	}else
	{
		unsigned int letter, drive, i;
		drive = dir->drive_letter;
		letter = dir->ent.d_name[0] - 64;
		letter++;
		for(i = 0; i < letter; i++)
			drive /= 2;

		for(i = letter; i < 32; i++)
		{
			if(drive % 2 == 1)
			{
				dir->ent.d_name[0] = 64 + i;
				return &dir->ent;
			}
			drive /= 2;
		}
		return NULL;
	}
}


#endif

/* Function for parsing directories, copied form Imagine. */

boolean make_make_path_search(char *file, boolean partial, char *path, boolean folders, unsigned int number, char *out_buffer, unsigned int out_buffer_size)
{
	unsigned int i, j, found = 0;
	DIR *d;
	idirent *ent;
	d = opendir(path);
	if(d != NULL)
	{
		ent = readdir(d);
		if(ent != NULL)
		{		
			out_buffer_size--;
			while(TRUE)
			{
				if(file == NULL)
				{
					if(found == number)
					{
						for(i = 0; ent->d_name[i] != 0 && i < out_buffer_size; i++)
							out_buffer[i] = ent->d_name[i];
						out_buffer[i] = 0;
						closedir(d);
						return TRUE;
					}
					found++;
				}else
				{
					if(partial)
					{
						for(i = 0; ent->d_name[i] != 0; i++)
						{
							if(ent->d_name[i] == file[0])
							{
								for(j = 0; ent->d_name[i + j] != 0 && file[j] != 0 && (ent->d_name[i + j] == file[j]); j++);
								if(file[j] == 0)
								{
									if(found == number)
									{
										for(i = 0; ent->d_name[i] != 0 && i < out_buffer_size; i++)
											out_buffer[i] = ent->d_name[i];
										out_buffer[i] = 0;
										closedir(d);
										return TRUE;
									}
									found++;
									break;
								}
							}
						}
					}else
					{
						for(i = 0; ent->d_name[i] != 0 && ent->d_name[i] == file[i]; i++);
						if(ent->d_name[i] == file[i])
						{
							if(found == number)
							{
								for(i = 0; ent->d_name[i] != 0 && i < out_buffer_size; i++)
									out_buffer[i] = ent->d_name[i];
								out_buffer[i] = 0;
								closedir(d);
								return TRUE;
							}
							found++;
						}
					}
				}
				ent = readdir(d);
				if(ent == NULL)
					break;
			}
		}
		closedir(d);
	}
	return FALSE;
}



void make_make_list_add(MakeMakeList *list, char *token)
{
	unsigned int i;
	for(i = 0; TRUE; i++)
	{
		if(list->array_length % MAKE_MAKE_TEXT_ALLOCATION_SIZE == 0)
			list->array = realloc(list->array, MAKE_MAKE_TEXT_ALLOCATION_SIZE + list->array_length);
		list->array[list->array_length++] = token[i];
		if(token[i] == 0)
			break;
	}
}

unsigned int make_make_list_next(MakeMakeList *list, unsigned int pos)
{	
	if(pos < list->array_length)
	{
		while(list->array[pos] != 0)
			pos++;
		pos++;
	}
	if(pos >= list->array_length)
		return ~0;
	return pos;
}


int make_make_list_test(MakeMakeList *list, char *token)
{
	unsigned int i, j;
	for(i = 0; i < list->array_length; i++)
	{
		for(j = 0; list->array[i] != 0 && token[j] == list->array[i]; i++)
			j++;
		if(token[j] == list->array[i])
			return TRUE;
		while(list->array[i] != 0)
			i++;
	}
	return FALSE;
}

void make_make_definition_list(MakeMakeFile *file, char *buffer, unsigned int file_length)
{
	char b[MAKE_MAKE_TOKEN_LENGTH_MAX];
	unsigned int i, j, k;
	char end;
	for(i = 0; i < file_length; i++)
	{
		if(buffer[i] == '(')
		{
			for(j = i + 1; j < file_length && buffer[j] != ';' && buffer[j] != '{' && buffer[j] != '(' && buffer[j] != '='; j++);
			end = buffer[j];
			for(j = i - 1; j != 0 && buffer[j] <= ' '; j--); // remove white space;
			for(; j != 0 && ((buffer[j] >= 'a' && buffer[j] <= 'z') ||
							(buffer[j] >= 'A' && buffer[j] <= 'Z') ||
							(buffer[j] >= '0' && buffer[j] <= '9') ||
							buffer[j] == '_'); j--); // parse the name;
			j++;
			for(k = 0; j < file_length && k < MAKE_MAKE_TOKEN_LENGTH_MAX && buffer[j] >= ' ' && buffer[j] != '('; k++)
				b[k] = buffer[j++];
			if(k > 2 && k < MAKE_MAKE_TOKEN_LENGTH_MAX)
			{
				b[k] = 0;
				if(end == '{')
				{
				//	printf("Defining %s: %s\n", file->file_name, b);
					make_make_list_add(&file->lists[MM_LT_DEFINITIONS], b);
				}
			}
		}
	}
}

void make_make_declaration_list(MakeMakeFile *file, char *buffer, unsigned int file_length)
{
	char b[MAKE_MAKE_TOKEN_LENGTH_MAX], *key_word = "extern", *exception_main = "main";
	unsigned int i, j, k;
	for(i = 0; i < file_length; i++)
	{
		if(buffer[i] <= ' ')
		{
			i++;
			for(j = 0; i + j < file_length && buffer[i + j] == key_word[j]; j++);
			if(0 == key_word[j] && buffer[i + j] <= ' ')
			{
				i += j;
				for(j = i + 1; j < file_length && buffer[j] != ';' && buffer[j] != '{' && buffer[j] != '('; j++);
				if(buffer[j] == '(')
				{
					i = j;
					for(j++; j < file_length && buffer[j] != ';' && buffer[j] != '(' && buffer[j] != '='; j++);
						
					if(buffer[j] == ';') /* ignore function pointers*/
					{
						while(i > 1 && buffer[i - 1] <= ' ') // remove white space;
							i++;
						for(j = i - 1; j != 0 && ((buffer[j] >= 'a' && buffer[j] <= 'z') ||
												(buffer[j] >= 'A' && buffer[j] <= 'Z') ||
												(buffer[j] >= '0' && buffer[j] <= '9') ||
												buffer[j] == '_'); j--); // parse the name;
						j++;
						for(k = 0; j < file_length && k < MAKE_MAKE_TOKEN_LENGTH_MAX && buffer[j] >= ' ' && buffer[j] != '('; k++)
							b[k] = buffer[j++];
						if(k > 2 && k < MAKE_MAKE_TOKEN_LENGTH_MAX)
						{
							b[k] = 0;							
							for(k = 0; b[k] == exception_main[k] && b[k] != 0; k++);
							if(b[k] != exception_main[k])
								make_make_list_add(&file->lists[MM_LT_DECLARATIONS], b);
						}
					}
				}
			}
		}
	}
}



unsigned int make_make_option_list(MakeMakeProject *project, char *buffer, unsigned int buffer_length, FILE *f, char *property, char *separator)
{
	unsigned int i, offset, used = 0, separator_size;
	boolean first = TRUE;
	for(separator_size = 0; separator[separator_size] != 0; separator_size++);
	for(i = 0; i < project->options.array_length; i = make_make_list_next(&project->options, i))
	{
		for(offset = 0; property[offset] == project->options.array[i + offset]; offset++);
		if(property[offset++] == 0)
		{
			if(!first)
			{
				memcpy(&buffer[used], separator, separator_size);
				used += separator_size;
			}
			first = FALSE;
			for(offset++; project->options.array[i + offset] != 0; offset++)
				buffer[used++] = project->options.array[i + offset];
			if(f != NULL)
			{
				buffer[used] = 0;
				fprintf(f, "%s", buffer);
				used = 0;
			}
		}
	}
	buffer[used] = 0;
	return used;
}

char *make_make_option_get(MakeMakeProject *project, char *property)
{
	unsigned int i, offset, used = 0;
	boolean first = TRUE;
	for(i = 0; i < project->options.array_length; i = make_make_list_next(&project->options, i))
	{
		for(offset = 0; property[offset] == project->options.array[i + offset]; offset++);
		if(property[offset++] == 0)
		{
			return &project->options.array[i + offset];
		}
	}
	return NULL;
}

int make_make_option_test(MakeMakeProject *project, char *property, char *value)
{
	unsigned int i, j, offset, used = 0;
	boolean first = TRUE;
	for(i = 0; i < project->options.array_length; i = make_make_list_next(&project->options, i))
	{
		for(offset = 0; property[offset] == project->options.array[i + offset]; offset++);
		if(property[offset++] == 0)
		{
			for(j = 0; project->options.array[i + offset + j] == value[j] && project->options.array[i + offset + j] != 0; j++);
			if(project->options.array[i + offset + j] == 0)
				return TRUE;
		}
	}
	return FALSE;
}


char *make_make_text_load(char *file_name, size_t *size)
{
	char *buffer;
	unsigned int allocation;
	FILE *f;
	f = fopen(file_name, "rb");
	if(f == NULL)
	{
		return NULL;
	}
	fseek(f, 0, SEEK_END);
	allocation = ftell(f);
	if(allocation == 0)
	{
		fclose(f);
		return NULL;
	}
	rewind(f);
	buffer = malloc(allocation + 1);
	memset(buffer, 0, allocation + 1);
	fread(buffer, 1, allocation, f);
	fclose(f);
	buffer[allocation] = 0;
	if(size != NULL)
		*size = allocation;
	return buffer;
}

void make_make_include(MakeMakeList *list, char *buffer, unsigned int buffer_length)
{
	char b[64];
	char *include = "include";
	unsigned int i, j;
	for(i = 0; i < buffer_length; i++)
	{
		if(buffer[i] == '#')
		{
			i++;
			for(j = 0; i + j < buffer_length && buffer[i + j] == include[j]; j++);
			i += j;
			if(include[j] == 0)
			{
				while(i < buffer_length && buffer[i] <= ' ')
					i++;
				if(i < buffer_length && buffer[i] == '\"')
				{
					i++;
					for(j = 0; j < 63 && buffer[i + j] != '\"'; j++)
						b[j] = buffer[i + j];
					b[j] = 0;
					make_make_list_add(list, b);
				}
			}
		}
	}
}



void make_make_find_next(char *file, unsigned int file_length, char start, char end)
{
		unsigned int i, count;
	for(i = 0; i < file_length; i++)
	{
		if(file[i] == start)
		{
			count = 1;
			for(i++; TRUE; i++)
			{
				if(file[i] == start)
					count++; 
				if(file[i] == end)
					if(--count == 0)
						break;
				file[i] = ' '; 
			}
		}
	}
}

void make_make_remove_span(char *file, unsigned int file_length, char start, char end)
{
	unsigned int i, count;
	for(i = 0; i < file_length; i++)
	{
		if(file[i] == start)
		{
			count = 1;
			for(i++; i < file_length; i++)
			{
				if(file[i] == start)
					count++; 
				if(file[i] == end)
					if(--count == 0)
						break;
				file[i] = ' '; 
			}
		}
	}
}

void make_make_remove(char *file, unsigned int file_length, char *start, char *end)
{
	unsigned int i, j;
	for(i = 0; i < file_length;)
	{
		for(j = 0; i + j < file_length && file[i + j] == start[j] && start[j] != 0; j++);
		if(start[j] == 0)
		{
			for(j = 0; i < file_length && start[j] != 0; j++)
				file[i++] = ' '; 
			while(i < file_length)
			{
				for(j = 0; file[i + j] == end[j] && end[j] != 0; j++);
				if(end[j] == 0)
				{
					for(j = 0; end[j] != 0; j++)
						file[i++] = ' ';
					break;
				}
				if(file[i] == '\\')
				{
					file[i++] = ' ';
					while(file[i] <= ' ')
						file[i++] = ' ';
				}
				file[i++] = ' ';
			}
		}else
			i++;
	}
}
unsigned int make_make_compact(char *file, unsigned int file_length)
{
	unsigned int i, breaks = 0;
	char *r, *w;
	for(i = 0; i < file_length; i++)
		if(file[i] == '/t')
			file[i] = ' ';
	for(i = 0; i < file_length; i++)
	{
		if(file[i] != ' ')
		{
			if(file[i] != '\n' && file[i] != '\r')
				breaks = 0;
			else
				if(++breaks > 2)
					file[i] = ' ';
		}
	}
	r = w = file;
	for(i = 0; i < file_length; i++)
	{
		*w++ = *r;
		if(*r++ == ' ')
		{
			while(*r == ' ' && i < file_length)
			{
				r++;
				i++;
			}
		}
	}
	*w = '\0';
	return w - file;
}

void make_make_pragma(MakeMakeProject *project, char *file, unsigned int file_length, MakeMakeList *list)
{
	char *pragma = "#pragma", *makemake = "makemake", buffer_a[MAKE_MAKE_TOKEN_LENGTH_MAX], buffer_b[MAKE_MAKE_TOKEN_LENGTH_MAX];
	unsigned int i, j;
	for(i = 0; i < file_length; i++)
	{
		if(file[i] == '#')
		{
			for(j = 0; i + j < file_length && pragma[j] == file[i + j]; j++);
			if(pragma[j] == 0)
			{
				for(i += j; i < file_length && file[i] != '\n' && file[i] <= ' '; i++); /* skip white space */
				if(file[i] != '\n')
				{
					for(j = 0; i + j < file_length && makemake[j] == file[i + j]; j++);
					if(makemake[j] == 0)
					{
						for(i += j; i < file_length && file[i] != '\n' && file[i] <= ' '; i++); /* skip white space */
						if(file[i] != '\n')
						{
							for(j = 0; i + j < file_length && file[i + j] > ' ' && j < MAKE_MAKE_TOKEN_LENGTH_MAX - 1; j++)
								buffer_a[j] = file[i + j];
							buffer_a[j] = ' ';
							for(i += j; i < file_length && file[i] != '\n' && file[i] <= ' '; i++); /* skip white space */
							if(file[i] != '\n')
							{
								buffer_a[j++] = ' ';
								for(; i < file_length && file[i] > ' ' && j < MAKE_MAKE_TOKEN_LENGTH_MAX - 1; j++)
									buffer_a[j] = file[i++];
								buffer_a[j] = 0;
								for(; i < file_length && file[i] != '\n' && file[i] <= ' '; i++); /* skip white space */
					
								if(i < file_length && file[i] != '\n') /* has platform */
								{
									if(make_make_option_test(project, "platform", &file[i]))
										make_make_list_add(list, buffer_a);
								}else
									make_make_list_add(list, buffer_a);
							}
						}
					}
				}
			}
		}
	}
}

void make_make_parse_file(MakeMakeProject *project, char *full_path, char *file_name, int header, char *platform)
{
	MakeMakeFile *file;
	size_t size;
	char *buffer;
	unsigned int i;
	buffer = make_make_text_load(full_path, &size);
	if(buffer == NULL)
		return;
	if(project->file_count % 128 == 0)
		project->files = realloc(project->files, (sizeof *project->files) * (project->file_count + 128));
	file = &project->files[project->file_count++];
	for(i = 0; i < MM_LT_COUNT; i++)
	{
		file->lists[i].array = NULL;
		file->lists[i].array_length = 0;
	}
	for(i = 0; file_name[i] != 0; i++)
		file->file_name[i] = file_name[i];
	file->file_name[i] = 0;
	file->added = FALSE;
	file->header = header;
	make_make_remove(buffer, size, "//", "\n");
	make_make_remove(buffer, size, "/*", "*/");
	make_make_pragma(project, buffer, size, &file->lists[MM_LT_PRAGMA]);

	make_make_include(&file->lists[MM_LT_INCLUDES], buffer, size);	
	make_make_remove(buffer, size, "#", "\n");
//	make_make_remove(buffer, size, "(*", ")");
	make_make_remove_span(buffer, size, '{', '}');
	make_make_remove_span(buffer, size, '(', ')');
	size = make_make_compact(buffer, size);
	make_make_declaration_list(file, buffer, size);
	make_make_definition_list(file, buffer, size);
	buffer[size] = 0;
	free(buffer);
}

MakeMakeFile *make_make_file_find(MakeMakeFile *files, unsigned int file_count, char *file_name, MakeMakeFile *parent)
{
	unsigned int i, j;
	for(i = 0; TRUE; i++)
	{
		if(i == file_count)
			return NULL;
		for(j = 0; file_name[j] == files[i].file_name[j] && file_name[j] != 0; j++);
		if(file_name[j] == files[i].file_name[j])
		{
			if(parent != NULL && !files[i].added)
				printf(" - %s : Is included in %s\n", files[i].file_name, parent->file_name);
			return &files[i];
		}
	}	
}

MakeMakeFile *make_make_definition_find(MakeMakeFile *files, unsigned int file_count, char *declaration, MakeMakeFile *parent)
{
	unsigned int i, j, k;
	for(i = 0; i < file_count; i++)
	{
		if(!files[i].added)
		{
			if(make_make_list_test(&files[i].lists[MM_LT_DEFINITIONS], declaration))
			{
				printf(" - %s : Added because it declares %s required by %s\n", files[i].file_name, declaration, parent->file_name);
				return &files[i];
			}
		}
	}	
	return NULL;
}


void make_make_file_add(MakeMakeFile *files, unsigned int file_count, MakeMakeFile *f)
{
	unsigned int i;
	if(f == NULL || f->added)
		return;
	f->added = TRUE;
	for(i = 0; i < f->lists[MM_LT_DECLARATIONS].array_length; i = make_make_list_next(&f->lists[MM_LT_DECLARATIONS], i))
		make_make_file_add(files, file_count, make_make_definition_find(files, file_count, &f->lists[MM_LT_DECLARATIONS].array[i], f));
	
	for(i = 0; i < f->lists[MM_LT_INCLUDES].array_length; i = make_make_list_next(&f->lists[MM_LT_INCLUDES], i))
		make_make_file_add(files, file_count, make_make_file_find(files, file_count, &f->lists[MM_LT_INCLUDES].array[i], f));
}


void make_make_gather_options(MakeMakeProject *project)
{
	unsigned int i, j, k;
	for(i = 0; i < project->file_count; i++)
		if(project->files[i].added && project->files[i].lists[MM_LT_PRAGMA].array_length != 0)
			for(j = 0; j < project->files[i].lists[MM_LT_PRAGMA].array_length; j = make_make_list_next(&project->files[i].lists[MM_LT_PRAGMA], j))
				make_make_list_add(&project->options, &project->files[i].lists[MM_LT_PRAGMA].array[j]);
	for(i = 0; i < project->options.array_length; i = make_make_list_next(&project->options, i))
		printf(" - %s\n", &project->options.array[i]);
	return NULL;
}

/*
Function that generates a make file:
Use "make_make_option_get" and "make_make_option_list" to retrive any options needed.
options are added to .c files using the following syntax:
#pragma makamake <option name> <option> <optional platform>
*/


void make_make_posix(MakeMakeProject *project, FILE *f)
{
	char buffer[128];
	unsigned int i, j;
	fprintf(f, "TARGETNAME := bin/%s\n"
				"BASE_DIR=%s\n", make_make_option_get(project, "name"), project->path);
	fprintf(f, "CFLAGS=-Wall -I$(BASE_DIR) -g -pipe -Wno-deprecated-declarations -fno-omit-frame-pointer -ggdb -ffunction-sections -O0");
	make_make_option_list(project, buffer, 128, f, "compilerflag", " ");
	fprintf(f, "\nLDFLAGS=-g -Wl,-gc-sections\n"
				"CC_SOURCE_FILES=$(wildcard", make_make_option_get(project, "name"), project->path);
	for(i = 0; i < project->file_count; i++)
		if(project->files[i].added)
			fprintf(f, "$(BASE_DIR)/%s", project->files[i].file_name);
	fprintf(f, ")\nLD_LIBS=-lm ");
	make_make_option_list(project, buffer, 128, f, "lib", " ");
	fprintf(f, "\n"
		"CC_OBJS=${CC_SOURCE_FILES:.c=.o}\n"
		"%%.d: %%.c\n"
		"	@$(CC) $(CCFLAGS) $< -MM -MT $(@:.d=.o) >$@\n"
		".DEFAULT_GOAL := all\n"
		"all: bin/%s\n"
		"bin/%s: $(CC_SOURCE_FILES) $(CC) $(CCFLAGS) -Wl,-rpath '-Wl,$$ORIGIN' -o $@ $(CC_OBJS) $(LD_LIBS)\n"
		"analyze:\n"
		"	scan-build $(CC) $(CCFLAGS) $(CC_SRCS)\n"
		"clean:\n"
		"	rm bin/*\n"
		"	rm $(BASE_DIR)/*.o\n"
		".PHONY: clean all\n", make_make_option_get(project, "name"), make_make_option_get(project, "name"));
}

int main(int argc, char **argv)
{
	char file_name[1024], option_buffer[MAKE_MAKE_TOKEN_LENGTH_MAX], path_buffer[1024], *s, *platform = "", *home = DIR_HOME_PATH;
	unsigned int i, j, k, path_length;
	MakeMakeFile *file;
	MakeMakeProject project;
	FILE *f;
	char *option, *t = "stdout";
//	char *argv[] = {"something", "C:\\Mergesource\\t_test.c", "-name", "test", "-makefile", "stdout"};
//	argc = 6;

	project.files = NULL;
	project.file_count = 0;
	project.options.array = NULL;
	project.options.array_length = 0;
	if(argc <= 1)
	{
		printf("MakeMake\n--------\n");
		printf("MakeMake is a command line tool that generates a make file form a single .c file by scanning and traversing includes and defines in files in the same directory.\n\n");
		printf("\nMakeMake is free and opensource nder the MIT License.\nWritten by Eskil Steenberg Hald eskil@quelsolaar.com www.quelsolaar.com eskil@quelsolaar.com.\n\n");
		printf("Usage:\n------\n");
		printf("\t-makemake <c file> <options>\n\nOptions:\n--------\n");
		printf("\t-name <name> Name of the executable \n");
		printf("\t-makefile <name> Name of the make file (or stdout)\n");
		printf("\t-compilerflag <flag> Custom compiler flags.\n");
		printf("\t-platform <name> Platform define\n");
		printf("\t-lib <name> Library dependency\n\n");
		printf("Options can be added in .c and .h files using the following pragma:\n");
		printf("\t#pragma makemake <option name> <option> <optional platform>\n\n");
		printf("If a platform is defined, the option is only active when that platform is defined. More than one platform can be defined simultaniusly (Example \"linux\" and \"posix\")\n");
		return TRUE;
	}

	j = ~0;
	for(i = 0; i < 1024 && argv[1][i] != 0; i++)
		if(argv[1][i] == DIR_SLASH)
			j = i;
	if(i == 1024)
	{
		for(i = 0; argv[1][i] != 0; i++);
		printf("MakeMake Error: Path is too long: %u bytes (MAX: 1024)\n", i);
		return FALSE;
	}	
	if(j == ~0)
	{
		for(path_length = 0; path_length < 1024 && home[path_length] != 0; path_length++)
			path_buffer[path_length] = project.path[path_length] = home[path_length];
		path_buffer[path_length] = project.path[path_length] = 0;
		for(i = 0; i < 1024 && argv[1][i] != 0; i++)
			file_name[i] = argv[1][i];
		file_name[i] = 0;
	}else
	{
		j++;
		for(path_length = 0; path_length < j; path_length++)
			path_buffer[path_length] = project.path[path_length] = argv[1][path_length];
		path_buffer[path_length] = project.path[path_length] = 0;
		for(i = 0; i < 1024 && argv[1][i + j] != 0; i++)
			file_name[i] = argv[1][i + j];
		file_name[i] = 0;
	}
	for(i = 2; i < argc - 1; i++)
	{                  
		if(argv[i][0] == '-')
		{
			for(j = 0; j < MAKE_MAKE_TOKEN_LENGTH_MAX && argv[i][j + 1] != 0; j++)
				option_buffer[j] = argv[i][j + 1];
			if(j < MAKE_MAKE_TOKEN_LENGTH_MAX - 1)
			{
				i++;
				option_buffer[j++] = ' ';
				for(k = 0; j < MAKE_MAKE_TOKEN_LENGTH_MAX - 1 && argv[i][k] != 0; k++)
					option_buffer[j++] = argv[i][k];
				option_buffer[j] = 0;
				make_make_list_add(&project.options, option_buffer);
			}
		}
	}
	if(NULL == make_make_option_get(&project, "platform"))
	{
#ifdef	__linux__
		make_make_list_add(&project.options, "platform linux");
		make_make_list_add(&project.options, "platform posix");
#endif 
#ifdef	_WIN32
		make_make_list_add(&project.options, "platform win32");
#endif 
#ifdef	__ANDROID__
		make_make_list_add(&project.options, "platform android");
		make_make_list_add(&project.options, "platform posix");
#endif 
#ifdef	MACOSX
		make_make_list_add(&project.options, "platform macosx");
		make_make_list_add(&project.options, "platform posix");
#endif 
	}

	printf("Parsing files...\n");
	for(i = 0; make_make_path_search(".c", TRUE, project.path, FALSE, i, &path_buffer[path_length], 1024 - path_length); i++)
		make_make_parse_file(&project, path_buffer, &path_buffer[path_length], FALSE, platform);
	for(i = 0; make_make_path_search(".h", TRUE, project.path, FALSE, i, &path_buffer[path_length], 1024 - path_length); i++)
		make_make_parse_file(&project, path_buffer, &path_buffer[path_length], TRUE, platform);

	if(NULL == make_make_option_get(&project, "name"))
	{
		option_buffer[0] = 'n';
		option_buffer[1] = 'a';
		option_buffer[2] = 'm';
		option_buffer[3] = 'e';
		option_buffer[4] = ' ';
		for(i = 0; i < 63 && file_name[i] != 0 && file_name[i] != '.' && i + 6 < MAKE_MAKE_TOKEN_LENGTH_MAX; i++)
			option_buffer[i + 5] = file_name[i];
		option_buffer[i + 5] = 0;
		make_make_list_add(&project.options, option_buffer);
	}

	file = make_make_file_find(project.files, project.file_count, file_name, NULL);
	if(file == NULL)
	{
		printf("MakeMake Error: %s not found\n", file_name);
		return FALSE;
	}
	
	printf("Traversing files...\n");
	make_make_file_add(project.files, project.file_count, file);
	printf("Gather options...\n");
	make_make_gather_options(&project);
	printf("Generating makefile...\n");
	option = make_make_option_get(&project, "makefile");
	if(option == NULL)
		option = "makefile";
	for(i = 0; option[i] != 0 && option[i] == t[i]; i++);
	if(option[i] == t[i])
		f = stdout;
	else
		f = fopen(option, "w");
	if(f == NULL)
	{
		printf("MakeMake Error: Failed to open file %s for writing");
		return 1;
	}
	
	if(make_make_list_test(&project.options, "platform android"))
		make_make_posix(&project, f); /* write different function for different OS */
	else if(make_make_list_test(&project.options, "platform macosx"))
		make_make_posix(&project, f); /* write different function for different OS */
	else if(make_make_list_test(&project.options, "platform win32"))
		make_make_posix(&project, f); /* write different function for different OS */
	else if(make_make_list_test(&project.options, "platform linux"))
		make_make_posix(&project, f); /* write different function for different OS */
	else if(make_make_list_test(&project.options, "platform posix"))
		make_make_posix(&project, f); /* check for posix last, as it is asubset of unix platforms! */
	if(f != stdout)
		fclose(f);
	printf("MakeMake Sucsess!");
	return TRUE;
}