#ifdef DEPRICATED
#include <string.h>
#include "forge.h"
#include "imagine.h"
#include "testify.h"

const char *testify_discovery_global_character_transform_new = "zxvtsrqpnmkjhgdb";
const char *testify_discovery_global_character_transform = "lfcmugypwbvkjxqz";
#define TESTIFY_DISCOVER_USER_NAME_LENGTH 12

void testify_discover_global_encode(char *output, uint8 *input, uint input_count, boolean terminate)
{
	uint i;
	for(i = 0; i < input_count; i++)
	{
		output[i * 2] = testify_discovery_global_character_transform[input[i] / 16];
		output[i * 2 + 1] = testify_discovery_global_character_transform[input[i] % 16];
	}
	if(terminate)
		output[i * 2] = 0;
}

uint testify_discover_global_decode(char *output, uint8 *input, uint output_max)
{
	uint i = 0, j;
	output_max *= 2;
	while(i < output_max)
	{
		for(j = 0; j < 16 && testify_discovery_global_character_transform[j] != input[i]; j++);
		if(j == 16)
			return i / 2;
		output[i / 2] = j * 16;
		i++;
		for(j = 0; j < 16 && testify_discovery_global_character_transform[j] != input[i]; j++);
		if(j == 16)
			return i / 2;
		output[i / 2] += j;
		i++;
	}
	return i / 2;
}


THandle *testify_irc_create(char *server, char *user_name, char *channel)
{
	char *servers[11] = {"irc.dal.net", "irc.quakenet.org", "chat.freenode.net", "irc.gamesurge.net", "open.ircnet.net", "irc.rizon.net", "irc.swiftirc.net", "eu.undernet.org", "us.undernet.org", "irc.webchat.org", "irc.2600.net"};
	TestifyAddress address;
	THandle *handle = NULL;
	char *read, rand[6], message[512];
	uint i;
	if(testify_address_lookup(&address, server, TESTIFY_TRANSPORT_IPV4, 6667))
			handle = testify_create(&address, TESTIFY_PROTOCOL_STREAM, 0);
	if(handle != NULL)
	{
		sprintf(message, "NICK %s\r\n", user_name);
		printf("sending:%s", message);
		for(i = 0; message[i] != 0; i++);
		testify_stream_send(handle, message, i);
		sprintf(message, "USER %s 8 * : %s\r\n", user_name, user_name);
		printf("sending:%s", message);
		for(i = 0; message[i] != 0; i++);
		testify_stream_send(handle, message, i);

		sprintf(message, "JOIN #%s\r\n", channel);
		printf("%s", message);
		for(i = 0; message[i] != 0; i++);
		testify_stream_send(handle, message, i);

	}
	return handle;
}


void testify_discover_global_comand_parse(TestifyHandle* handle, char *service, uint16 service_port, char *messageX, char *buffer, uint buffer_size)
{
	uint8 *read, *command, *payload, *name, tmp_buffer[512], channel[64 + 1], *dns;
	uint i;
	read = buffer;
	if(read[0] == ':')
	{
		while(*read > ' ')
			read++;
		while(*read <= ' ' && *read != 0)
			read++;
	}
	command = read;
	while(*read != 0 && *read != ':')
		read++;
	if(*read != 0)
		payload = ++read;
	else
		payload = NULL;
	name = NULL; 
	if(buffer[0] == ':')
	{
		for(i = 1; buffer[i] != '!' && buffer[i] != 0; i++);
		if(buffer[i] == '!' && i == TESTIFY_DISCOVER_USER_NAME_LENGTH + 1)
		{
			buffer[i] = 0;
			name = &buffer[1];
		}
	}
	/* parse the various commands */

	if(command[0] >= '0' && command[0] <= '9')
	{
		if(command[0] == '0' && command[1] == '0' && command[2] == '1') /* welcome command we are connected*/
		{
			printf("Wellcome!\n");
			for(i = 0; i < 32 && service[i] != 0; i++);	
			testify_discover_global_encode(channel, service, i, TRUE);
			sprintf(tmp_buffer, "JOIN #%s\r\n", channel);
			printf("%s", tmp_buffer);
			for(i = 0; tmp_buffer[i] != 0; i++);
			testify_stream_send(handle, tmp_buffer, i);
		}
	}else if(command[0] == 'P' && command[1] == 'R' && command[2] == 'I' && command[3] == 'V' && command[4] == 'M' && command[5] == 'S' && command[6] == 'G' && command[7] == ' ') /* We have sucsessfully joined our channel. */
	{
		if(buffer[0] == ':')
		{
			dns = &buffer[1];
			for(i = 1; i < buffer_size && buffer[i] > ' '; i++)
				if(buffer[i] == '@')
					dns = &buffer[i + 1];
			if(i < buffer_size)
			{
				buffer[i++] = 0;
				printf("\tDns : %s\n", dns);
				for(; i < buffer_size && buffer[i] != ':'; i++);
				if(buffer[i] == ':')
				{
					TestifyAddress address;
					char address_string[TESTIFY_ADDRESS_MAX_STRING_SIZE];
					testify_address_lookup(&address, dns, TESTIFY_TRANSPORT_IPV4, 666);
					testify_address_print(&address, address_string);
					printf("\taddress : %s\n", address_string);
					printf("\tmessage : %s\n", &buffer[i + 1]);
				}
			}
		}		
	}else if(command[0] == 'P' && command[1] == 'I' && command[2] == 'N' && command[3] == 'G') /* Respond to ping commands to keep the client alive. */
	{
		testify_stream_send(handle, "PONG\r\n", 6);
	}else if(command[0] == 'J' && command[1] == 'O' && command[2] == 'I' && command[3] == 'N') /* Respond to ping commands to keep the client alive. */	
	{
		if(name != NULL)
		{
			printf("JOIN %s %s %s\n", buffer, name, payload);


		//	for(i = 0; user_name[i] != 0 && user_name[i] == name[i]; i++);
		//	if(user_name[i] != 0) /* remove any message from me*/
 		//	{
		//		for(i = 4; command[i] != 0 && command[i] != '#'; i++);
		//		if(command[i] == '#')
		//		{
		//			channel = &command[i + 1];
		//			d = testify_discover_channel(channel);
		//			if(d != NULL/* && ip_address != 0*/)
		//				testify_discover_pack_message(handle, d, name, 0, d->port, d->service);
		//		}
		//	}
		}
	}else if((command[0] == 'Q' && command[1] == 'U' && command[2] == 'I' && command[3] == 'T') ||
			(command[0] == 'P' && command[1] == 'A' && command[2] == 'R' && command[3] == 'T')) 
	{
		printf("QUIT %s\n", buffer);
		if(name != NULL)
		{
			printf("QUIT %s\n", name);
	//		for(j = 0; j < testify_discovery_count; j++)
	//			testify_discover_user_remove(&testify_discovery[j], name);
		}
	//	testify_pack_sting_nulless(handle, "PONG\r\n");
	//	testify_network_stream_send_force(handle);
	}else
		printf("Ignored message %s\n", buffer);
}

void testify_discover_global_update(TestifyHandle* handle, char *service, uint16 service_port, char *message, char *buffer, uint *buffer_used, uint buffer_size)
{
	uint start, i , length;

	if(*buffer_used == ~0)
	{	 
		start = ~0;
		length = 0;
	}else
	{
		length = *buffer_used;
		start = 0;
	}
	length += testify_stream_recive(handle, &buffer[length], buffer_size - length);

	for(i = 0; i < length; i++)
	{
		if(buffer[i] == '\n')
		{
			if(i > 0 && buffer[i - 1] == '\r')
				buffer[i - 1] = 0;
			buffer[i] = 0;
			if(start != ~0)
				testify_discover_global_comand_parse(handle, service, service_port, message, &buffer[start], i - start);
			start = i + 1;
		}
	}
	if(start == ~0)
		return;
	length -= start;
	if(start != 0)
	{
		for(i = 0; i < length; i++)
			buffer[i] = buffer[i + start];
	}else if(length == buffer_size)
		*buffer_used = -1;
}

#ifdef NOT_YET

THandle *testify_discover_global_connect()
{
	char *servers[11] = {"chat.freenode.net", "irc.dal.net", "irc.gamesurge.net", "open.ircnet.net", "irc.quakenet.org", "irc.rizon.net", "irc.swiftirc.net", "eu.undernet.org", "us.undernet.org", "irc.webchat.org", "irc.2600.net"};
	TestifyDiscovery *d;
	static THandle *handle = NULL;
	char *read, user_name[13] = {0}, rand[6], message[17 + 12 * 2];
	uint i;
	imagine_mutex_lock(testify_discover_list_mutex);
	for(d = testify_discover_list; d != NULL || d->global; d = d->next);
	imagine_mutex_unlock(testify_discover_list_mutex);
	if(d == NULL)
	{
		if(handle != NULL)
		{
			testify_free(handle);
			handle = NULL;
		}
		return NULL;
	}
	if(handle != NULL)
		return handle;
	if(testify_network_adapter_count() > 0)
	{
		for(i = 0; i < 11 && (handle = testify_network_stream_address_create(servers[i], 6667)) == NULL; i++);
		if(handle != NULL)
		{
			testify_discover_encode(user_name, testify_discover_id, 6, TRUE);
			sprintf(message, "NICK %s\r\n", user_name);
			testify_pack_sting_nulless(handle, message);
			sprintf(message, "USER %s 8 * : %s\r\n", user_name, user_name);
			testify_pack_sting_nulless(handle, message);
			testify_network_stream_send_force(handle);
		}
	}
	return handle;
}
void testify_discover_global_update(THandle *handle)
{
	TestifyDiscovery *d;
	char address[4];
	char *read, reply[512], code[8 + 2 + 1], user, *command, *name, *payload, *channel;
	static char buffer[512], user_name[13] = {0};
	static buffer_length = 0;
	static boolean init = FALSE, connected = FALSE;
	static uint32 ip_address = 0;
	uint32 tmp;
	uint i, j, length, adapter_count;

	/* Global discovery */
	while(testify_retivable(handle, 1))
	{
		buffer[buffer_length++] = testify_unpack_int8(handle, "");
		if(buffer_length >= 2 && buffer[buffer_length - 1] == '\n')
		{
			buffer[buffer_length] = 0;
			read = buffer;
			if(read[0] == ':')
			{
				while(*read > ' ')
					read++;
				while(*read <= ' ' && *read != 0)
					read++;
			}
			command = read;
			while(*read != 0 && *read != ':')
				read++;
			if(*read != 0)
				payload = ++read;
			else
				payload = NULL;
			name = NULL; 
			if(buffer[0] == ':')
			{
				for(i = 1; buffer[i] != '!' && buffer[i] != 0; i++);
				if(buffer[i] == '!' && i == TESTIFY_DISCOVER_USER_NAME_LENGTH + 1)
				{
					buffer[i] = 0;
					name = &buffer[1];
				}
			}
			if(command[0] >= '0' && command[0] <= '9')
			{
				if(command[0] == '0' && command[1] == '0' && command[2] == '1') /* welcome command we are connected*/
					connected = TRUE;
			}else if(command[0] == 'P' && command[1] == 'R' && command[2] == 'I' && command[3] == 'V' && command[4] == 'M' && command[5] == 'S' && command[6] == 'G' && command[7] == ' ') /* We have sucsessfully joined our channel. */
			{
				if(name != NULL)
					testify_discover_parse_message(name, payload);
			}else if(command[0] == 'P' && command[1] == 'I' && command[2] == 'N' && command[3] == 'G') /* Respond to ping commands to keep the client alive. */
			{
				testify_pack_sting_nulless(handle, "PONG\r\n");
				testify_network_stream_send_force(handle);
			}else if(command[0] == 'J' && command[1] == 'O' && command[2] == 'I' && command[3] == 'N') /* Respond to ping commands to keep the client alive. */	
			{
				if(name != NULL)
				{
					printf("JOIN %s %s %s\n", buffer, name, payload);
					for(i = 0; user_name[i] != 0 && user_name[i] == name[i]; i++);
					if(user_name[i] != 0) /* remove any message from me*/
 					{
						for(i = 4; command[i] != 0 && command[i] != '#'; i++);
						if(command[i] == '#')
						{
							channel = &command[i + 1];
							d = testify_discover_channel(channel);
							if(d != NULL/* && ip_address != 0*/)
								testify_discover_pack_message(handle, d, name, 0, d->port, d->service);
						}
					}
				}
		//		testify_discover_pack_message(handle, TestifyDiscovery *discovery, name, uint32 ip, uint16 port, char *message)
			//	testify_pack_sting_nulless(handle, "PONG\r\n");
			//	testify_network_stream_send_force(handle);
			}else if((command[0] == 'Q' && command[1] == 'U' && command[2] == 'I' && command[3] == 'T') ||
					(command[0] == 'P' && command[1] == 'A' && command[2] == 'R' && command[3] == 'T')) /* Respond to ping commands to keep the client alive. */
			{
				printf("QUIT %s\n", buffer);
				if(name != NULL)
					for(j = 0; j < testify_discovery_count; j++)
						testify_discover_user_remove(&testify_discovery[j], name);
			//	testify_pack_sting_nulless(handle, "PONG\r\n");
			//	testify_network_stream_send_force(handle);
			}else
				printf("Ignored message %s\n", buffer);
			buffer_length = 0;
		}
	}

	if(connected && discovery->joined)
	{
		j = testify_network_adapter_count();
		for(i = 0; i < j; i++)
		{
			tmp = testify_network_adapter_ipv4_global_address(i);
			if(tmp / (256 * 256 * 256) % 256 != 192) // FIX ME
			{
				if(tmp != 0 && connected && ip_address != tmp)
				{
					testify_discover_pack_message(handle, discovery, NULL, tmp);
					printf("updating ip address %u.%u.%u.%u\n", tmp % 256, (tmp / (256)) % 256, (tmp / (256 * 256)) % 256, (tmp / (256 * 256 * 256)) % 256);
				}
				ip_address = tmp;
				break;
			}
		}
	}

	if(connected && !discovery->joined)
	{
		char channel[256];
		for(i = 0; i < 32 && service[i] != 0; i++);
		discovery->joined = TRUE;
		testify_discover_encode(channel, service, i, TRUE);
		sprintf(reply, "JOIN #%s\r\n", channel);
		printf(reply);
		testify_pack_sting_nulless(handle, reply);
	//	sprintf(reply, "PRIVMSG #%s :YfYfYfYf\r\n", discovery->channel);
	//	printf(reply);
	//	testify_pack_sting_nulless(handle, reply);
		testify_network_stream_send_force(handle);
	}
}
#endif
#endif