
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include "forge.h"
#include "imagine.h"
#define TESTIFY_INTERNAL
#include "testify.h"


uint32 testify_portmap_ip_parse(char *string, uint size)
{
	uint number, pos = 0, shift = 24;
	uint32 ip = 0;
	while(TRUE)
	{
		for(number = 0; pos < size && string[pos] >= '0' && string[pos] <= '9'; pos++)
			number = (uint)string[pos] - '0' + number * 10;
		if(number > 255)
		{
			return 0;
		}
		ip += number << shift;
		if(shift == 0)
			return ip;
		shift -= 8;
		if(string[pos] != '.')
			return 0;
		pos++;
	}
}

boolean testify_http_whoami(char *host, TestifyAddress *output_address)
{
	TestifyAddress address;
	TestifyHandle *handle;
	char *string, buffer[1500], host_name[128], *path = "";
	int size, i, return_code;
	uint32 seconds_start, fractions_start, seconds, fractions;
	
	for(i = 0; i < 128 - 1 && host[i] != 0; i++)
	{
		if(host[i] == '/')
		{
			path = &host[i + 1];
			break;
		}
		host_name[i] = host[i];
	}
		
	host_name[i] = 0;
	if(!testify_address_lookup(&address, host_name, TESTIFY_TRANSPORT_IPV4, 80))
		return FALSE;
	// User-Agent: Testify\r\n
	size = snprintf(buffer, 1500, "GET /%s HTTP/1.1\r\nHost: %s\r\nDNT: 1\r\nSec-GPC: 0\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,;q=0.8\r\nAccept-Language: en-GB,en;q=0.5\r\nUpgrade-Insecure-Requests: 0\r\nAccept-Encoding: identity\r\nConnection: close\r\n\r\n", path, host_name);
	if(size < 0 && size >= 1500)
		return FALSE;
/*	printf("---- SEND ---\n");
	printf("%s", buffer);
	printf("---- END ----\n");*/
	handle = testify_create(&address, TESTIFY_PROTOCOL_STREAM, 0);
	if(handle == NULL)
		return FALSE;
	testify_stream_send(handle, buffer, size);
	buffer[0] = 0;
	address.transport = TESTIFY_TRANSPORT_IPV4;
	address.address.ipv4 = 0;
	address.port = 0;
	imagine_current_time_get(&seconds_start, &fractions_start);
	while(testify_connected(handle) && address.address.ipv4 == 0)
	{
		imagine_sleepd(0.01);
		size = (uint)testify_stream_recive(handle, buffer, 1500 - 1);
		if(size > 0)
		{
			buffer[size] = 0;			
			for(i = 0; i < size && buffer[i] > ' '; i++);
			if(++i < size)
			{				
				for(return_code = 0; i < size && buffer[i] >= '0' && buffer[i] <= '9'; i++)
					return_code = (buffer[i] - '0') + 10 * return_code;
				if(return_code == 511)
					testify_status_flags_set(TESTIFY_NS_BEHIND_LOGIN, 0);
			//	printf("Return Code %u\n", return_code);
				if(return_code / 100 == 2)
				{
					testify_status_flags_set(TESTIFY_NS_INTERNET_ACCESS_CONFIRMED, 0);
					for(i = size - 7; i > 4; i--)
					{
						if(buffer[i] == '\n' && buffer[i - 1] == '\r'  && buffer[i - 2] == '\n'  && buffer[i - 3] == '\r')
						{
							i++;
							for(; i < size; i++)
							{
								if(buffer[i] >= '0' && buffer[i] <= '9')
									if((address.address.ipv4 = testify_portmap_ip_parse(&buffer[i], size - i)) != 0)
										break;
							}
							break;
						}
					}
				}
			}
			break;
		}
		imagine_current_time_get(&seconds, &fractions);
		if(imagine_delta_time_compute(seconds_start, fractions_start, seconds, fractions) >= 1.0)
			break;
	}
	testify_destroy(handle);
	if(address.address.ipv4 != 0)
	{
		*output_address = address;
		return TRUE;
	}
	return FALSE;
}


